Bioinformatics Applications
==========================

Introduction
------------

In addition to the many applications available through modules (deployed through EasyBuild packaging system) we provide an alternative source of applications on our clusters inferred from Gentoo Linux ( www.gentoo.org ). The user's environment is setup through a script which returns a bash instance to the user (you can think of it a starting a whole virtual machine but inside your current namespace) . The applications were optimized by gcc compiler for the SandyBridge and IvyBridge platforms. The binaries use paths from /apps/gentoo prefix to find the required runtime dependencies, config files, etc. The Gentoo Linux is a standalone installation not even relying on the glibc provided by host operating system (Redhat). The trick which allowed us to install Gentoo Linux on the host Redhat system is called Gentoo::RAP and uses a modified loader with a hardcoded path ( https://wiki.gentoo.org/wiki/Prefix/libc ).


Starting the environment
------------------------

```bash
$ /apps/gentoo/startprefix
```

Starting PBS jobs using the applications
----------------------------------------

Create a template file which can be used and an argument to qsub command. Notably, the 'PBS -S' line specifies full PATH to the Bourne shell of the Gentoo Linux environment.

```bash
$ cat myjob.pbs
#PBS -S /apps/gentoo/bin/sh
#PBS -l nodes=1:ppn=16,walltime=12:00:00
#PBS -q qfree
#PBS -M my_email@foo.bar
#PBS -m ea
#PBS -N sample22
#PBS -A DD-13-5
#source ~/.bashrc

cd $PBS_O_WORKDIR || exit 255

myscript.sh foo 1>myjob.log 2>&1

$ head -n 1 myscript.sh
#! /apps/gentoo/bin/sh
$ qsub myjob.pbs
$ qstat
```

Reading manual pages for installed applications
-----------------------------------------------

```bash
$ man -M /apps/gentoo/usr/share/man bwa
$ man -M /apps/gentoo/usr/share/man samtools
```

Listing of bioinformatics applications
--------------------------------------

[gentoo_apps_on_anselm.doc](src/gentoo_apps_on_anselm.doc)


Classification of applications
------------------------------

[gentoo_apps_on_anselm.xls](src/gentoo_apps_on_anselm.xls)


Other applications available through Gentoo Linux
-------------------------------------------------

Gentoo Linux is a allows compilation of its applications from source code while using compiler and optimize flags set to user's wish. This facilitates creation of optimized binaries for the host platform. Users maybe also use several versions of gcc, python and other tools.

```bash
$ gcc-config -l
$ java-config -L
$ eselect
```
